import React from 'react';
import { RNIContextMenuView } from '../../native_components/RNIContextMenuView';
import type { ContextMenuViewProps, ContextMenuViewState, ContextMenuEventEmitter } from './ContextMenuViewTypes';
import type { MenuElementConfig } from '../../types/MenuConfig';
export declare class ContextMenuView extends React.PureComponent<ContextMenuViewProps, ContextMenuViewState> {
    static defaultProps: {
        useActionSheetFallback: boolean;
    };
    nativeRef: RNIContextMenuView;
    emitter: ContextMenuEventEmitter;
    constructor(props: ContextMenuViewProps);
    private getProps;
    dismissMenu: () => Promise<void>;
    provideDeferredElements: (deferredID: string, menuItems: MenuElementConfig[]) => Promise<void>;
    presentMenu: () => Promise<void>;
    showAuxiliaryPreviewAsPopover: () => Promise<void>;
    private _handleGetRefToContextMenuView;
    private _handleOnLongPress;
    private _handleOnMenuWillCreate;
    private _handleOnMenuWillShow;
    private _handleOnMenuWillHide;
    private _handleOnMenuWillCancel;
    private _handleOnMenuDidShow;
    private _handleOnMenuDidHide;
    private _handleOnMenuDidCancel;
    private _handleOnRequestDeferredElement;
    private _handleOnMenuAuxiliaryPreviewWillShow;
    private _handleOnMenuAuxiliaryPreviewDidShow;
    private _handleOnPressMenuItem;
    private _handleOnPressMenuPreview;
    render(): React.JSX.Element;
}
//# sourceMappingURL=ContextMenuView.d.ts.map