import * as React from 'react';
import { StyleSheet } from 'react-native';
import { RNIUtilitiesModule } from 'react-native-ios-utilities';
import { RNIContextMenuButtonModule } from './RNIContextMenuButtonModule';
import { RNIContextMenuNativeButton } from './RNIContextMenuNativeButton';
export class RNIContextMenuButton extends React.PureComponent {
    nativeRef;
    reactTag;
    constructor(props) {
        super(props);
    }
    ;
    componentWillUnmount() {
        const reactTag = this.getNativeReactTag();
        if (typeof reactTag !== 'number')
            return;
        RNIUtilitiesModule.notifyOnComponentWillUnmount(reactTag, {
            shouldForceCleanup: true,
            shouldIgnoreCleanupTriggers: false,
        });
    }
    ;
    getNativeRef = () => {
        return this.nativeRef;
    };
    getNativeReactTag = () => {
        // @ts-ignore
        return this.nativeRef?.nativeTag ?? this.reactTag;
    };
    presentMenu = async () => {
        const reactTag = this.getNativeReactTag();
        if (typeof reactTag !== 'number')
            return;
        await RNIContextMenuButtonModule.presentMenu(reactTag);
    };
    dismissMenu = async () => {
        const reactTag = this.getNativeReactTag();
        if (typeof reactTag !== 'number')
            return;
        await RNIContextMenuButtonModule.dismissMenu(reactTag);
    };
    provideDeferredElements = async (deferredID, menuItems) => {
        const reactTag = this.getNativeReactTag();
        if (typeof reactTag !== 'number')
            return;
        await RNIContextMenuButtonModule.provideDeferredElements(reactTag, {
            deferredID,
            menuItems
        });
    };
    _handleOnNativeRef = (ref) => {
        this.nativeRef = ref;
    };
    _handleOnLayout = ({ nativeEvent }) => {
        // @ts-ignore
        this.reactTag = nativeEvent.target;
    };
    render() {
        return React.createElement(RNIContextMenuNativeButton, {
            ...this.props,
            ...((this.reactTag == null) && {
                onLayout: this._handleOnLayout,
            }),
            style: [
                this.props.style,
                styles.nativeView
            ],
            // @ts-ignore
            ref: this._handleOnNativeRef,
        });
    }
    ;
}
;
const styles = StyleSheet.create({
    nativeView: {},
});
//# sourceMappingURL=RNIContextMenuButton.js.map