## F. Showcase, Tests and Demos

### `ContextMenuView` Test 01

**Summary**: Test for multiple nested/deep submenus.

[🔗 Source Code](example/src/examples/ContextMenuViewTest01.tsx)

![Gif](../assets/test-ContextMenuViewTest01.gif)

<br>

### `ContextMenuView` Test 02

**Summary**: Test for multiple inline menus + nested submenus.

[🔗 Source Code](example/src/examples/ContextMenuViewTest02.tsx)

![Gif](../assets/test-ContextMenuViewTest02.gif)

<br>

### `ContextMenuView` Test 03

**Summary**: Test for toggling the `menuState` on and off.

[🔗 Source Code](example/src/examples/ContextMenuViewTest03.tsx)

![Gif](../assets/test-ContextMenuViewTest03.gif)

<br>

### `ContextMenuView` Test 04

**Summary**: Test for changing the menu icons based on the current `menuState`.

[🔗 Source Code](example/src/examples/ContextMenuViewTest04.tsx)

![Gif](../assets/test-ContextMenuViewTest04.gif)

<br>

### `ContextMenuView` Test 05

**Summary**: Test for logging all the menu-related events.

[🔗 Source Code](example/src/examples/ContextMenuViewTest05.tsx)

![Gif](../assets/test-ContextMenuViewTest05.gif)

<br>

### `ContextMenuView` Test 06

**Summary**: Test for programmatically adding a menu action item.

[🔗 Source Code](example/src/examples/ContextMenuViewTest06.tsx)

![Gif](../assets/test-ContextMenuViewTest06.gif)

<br>

### `ContextMenuView` Test 07

**Summary**: Test for checking the different possible custom menu preview configurations.

[🔗 Source Code](example/src/examples/ContextMenuViewTest07.tsx)

![Gif](../assets/test-ContextMenuViewTest07.gif)

<br>

### `ContextMenuView` Test 08

**Summary**: Test for programmatically dismissing the menu.

[🔗 Source Code](example/src/examples/ContextMenuViewTest08.tsx)

![Gif](../assets/test-ContextMenuViewTest08.gif)

<br>

### `ContextMenuView` Test 09

**Summary**: Generate new 'deferredID' everytime the context menu is shown/hide. This is a test for `cleanupOrphanedDeferredElements`.

[🔗 Source Code](example/src/examples/ContextMenuViewTest09.tsx)

![Gif](../assets/test-ContextMenuViewTest09.gif)

<br>

### `ContextMenuView` Test 10

**Summary**: Test for nested menus, deferred elements, large icons, and small menus,

[🔗 Source Code](example/src/examples/ContextMenuViewTest10.tsx)

![Gif](../assets/test-ContextMenuViewTest10.gif)

<br>

### `ContextMenuAuxPreview` Test 01

**Summary**: TBA

[🔗 Source Code](example/src/examples/ContextMenuAuxPreviewTest01.tsx)

![Gif](../assets/test-ContextMenuAuxPreviewTest01.gif)

<br>

### `Test02Screen` 

**Summary**: Repro for [Issue #43](https://github.com/dominicstop/react-native-ios-context-menu/issues/43) 

[🔗 Source Code](example/src/screens/Test02Screen.tsx)

![Gif](../assets/screen-Test02Screen.gif)

<br>

### `Test03Screen` 

**Summary**: Repro for [Issue #47](https://github.com/dominicstop/react-native-ios-context-menu/issues/47)

[🔗 Source Code](example/src/screens/Test03Screen.tsx)

![Gif](../assets/screen-Test03Screen.gif)

<br><br>

## G. Meta

<br><br>

## H. Licence

[MIT](./LICENSE)

<br><br>

## Misc and Contact

* 🐤 **Twitter/X**: `@GoDominic`
* 💌 **Email**: `dominicgo@dominicgo.dev`
* 🌐 **Website**: [dominicgo.dev](https://dominicgo.dev)